## org.apache.commons.collections.map
Class AbstractOrderedMapDecorator

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.map.AbstractOrderedMapDecorator

All Implemented Interfaces:
  IterableMap, Map, OrderedMap

Direct Known Subclasses:
  UnmodifiableOrderedMap

public abstract class AbstractOrderedMapDecorator
extends AbstractMapDecorator
implements OrderedMap

Provides a base decorator that enables additional functionality to be added to an OrderedMap via decoration.

Methods are forwarded directly to the decorated map.

This implementation does not perform any special processing with the map views. Instead it simply returns the set/collection from the wrapped map. This may be undesirable, for example if you are trying to write a validating implementation it would provide a loophole around the validation. But, you might want that loophole, so this class is kept simple.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.7 $ $Date: 2004/04/02 21:17:48 $
Author:
  Stephen Colebourne

Nested Class Summary

Nested classes inherited from class java.util.Map
`Map.Entry`

Field Summary

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` `AbstractOrderedMapDecorator()` Constructor only used in deserialization, do not use otherwise.
`` `AbstractOrderedMapDecorator(OrderedMap map)` Constructor that wraps (not copies).

Method Summary
`Object` `firstKey()` Gets the first key currently in this map.
`protected OrderedMap` `getOrderedMap()` Gets the map being decorated.
`Object` `lastKey()` Gets the last key currently in this map.
`MapIterator` `mapIterator()` Obtains a `MapIterator` over the map.
`Object` `nextKey(Object key)` Gets the next key after the one specified.
`OrderedMapIterator` `orderedMapIterator()` Obtains an `OrderedMapIterator` over the map.
`Object` `previousKey(Object key)` Gets the previous key before the one specified.

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, entrySet, equals, get, getMap, hashCode, isEmpty, keySet, put, putAll, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Constructor Detail

### AbstractOrderedMapDecorator

    protected AbstractOrderedMapDecorator()

  Constructor only used in deserialization, do not use otherwise.

Since:
  Commons Collections 3.1

### AbstractOrderedMapDecorator

    public AbstractOrderedMapDecorator(OrderedMap map)

  Constructor that wraps (not copies).

Parameters:
  `map` - the map to decorate, must not be null
Throws:
  `IllegalArgumentException` - if the collection is null

Method Detail

### getOrderedMap

    protected OrderedMap getOrderedMap()

  Gets the map being decorated.

  Returns:
    the decorated map

### firstKey

    public Object firstKey()

  Description copied from interface: `OrderedMap`
  Gets the first key currently in this map.

  Specified by:
    `firstKey` in interface `OrderedMap`
  Returns:
    the first key currently in this map

### lastKey

    public Object lastKey()

  Description copied from interface: `OrderedMap`
  Gets the last key currently in this map.

  Specified by:
    `lastKey` in interface `OrderedMap`
  Returns:
    the last key currently in this map

### nextKey

    public Object nextKey(Object key)

  Description copied from interface: `OrderedMap`
  Gets the next key after the one specified.

  Specified by:
    `nextKey` in interface `OrderedMap`
  Parameters:
    `key` - the key to search for next from
  Returns:
    the next key, null if no match or at end

### previousKey

    public Object previousKey(Object key)

  Description copied from interface: `OrderedMap`
  Gets the previous key before the one specified.

  Specified by:
    `previousKey` in interface `OrderedMap`
  Parameters:
    `key` - the key to search for previous from
  Returns:
    the previous key, null if no match or at start

### mapIterator

    public MapIterator mapIterator()

  Description copied from interface: `IterableMap`
  Obtains a `MapIterator` over the map.

  A map iterator is an efficient way of iterating over maps. There is no need to access the entry set or cast to Map Entry objects.

       IterableMap map = new HashedMap();
       MapIterator it = map.mapIterator();
       while (it.hasNext()) {
         Object key = it.next();
         Object value = it.getValue();
         it.setValue("newValue");
       }

  Specified by:
    `mapIterator` in interface `IterableMap`
  Returns:
    a map iterator

### orderedMapIterator

    public OrderedMapIterator orderedMapIterator()

  Description copied from interface: `OrderedMap`
  Obtains an `OrderedMapIterator` over the map.

  A ordered map iterator is an efficient way of iterating over maps in both directions.

       BidiMap map = new TreeBidiMap();
       MapIterator it = map.mapIterator();
       while (it.hasNext()) {
         Object key = it.next();
         Object value = it.getValue();
         it.setValue("newValue");
         Object previousKey = it.previous();
       }

  Specified by:
    `orderedMapIterator` in interface `OrderedMap`
  Returns:
    a map iterator

Copyright © 2001-2005 Apache Software Foundation. All Rights Reserved.